var express = require('express');
var request = require('request');
var fs = require('fs');
var config = require('./config.json');

createAE();

function createAE(){
	console.log("\n▶▶▶▶▶");
	var representation = {
		"m2m:ae":{
			"rn":config.aeName,			
			"api": config.appId,
			"rr":"false"
		}
	};
	console.log("POST "+config.cseUri);
	console.log(representation);

	var options = {
		uri: config.cseUri,
		method: "POST",
		headers: {
			"X-M2M-Origin": config.aeId,
			"X-M2M-RI": "123456",
			"Content-Type": "application/json;ty=2"
		},
		json: representation
	};

	request(options, function (error, response, body) {
		console.log("◀◀◀◀◀");
		if(error){
			console.log(error);
		}else{
			console.log(response.statusCode);
			console.log(body);
			createContainer();
		}
	});
}


function createContainer(){
	console.log("\n▶▶▶▶▶");

	var representation = {
		"m2m:cnt":{
			"rn":config.cntName,
			"mni":config.cntMni		

		}
	};

	console.log("POST "+config.cseUri+"/"+config.aeName);
	console.log(representation);

	var options = {
		uri: config.cseUri+"/"+config.aeName,
		method: "POST",
		headers: {
			"X-M2M-Origin": config.aeId,
			"X-M2M-RI": "123456",
			"Content-Type": "application/json;ty=3"
		},
		json: representation
	};

	request(options, function (error, response, body) {
		console.log("◀◀◀◀◀");
		if(error){
			console.log(error);
		}else{
			console.log(response.statusCode);
			createContentInstance();
			console.log(body);
			setInterval(function() {
				createContentInstance();
			}, config.sleepTime);
		}
	});
}

function randomNumber(min, max) {
	return Math.random() * (max - min) + min;
}

var i=0;
var j=0;
function createContentInstance(){
	console.log("\n▶▶▶▶▶");
	var measure = Math.sin(i)+randomNumber(-0.2, 0.2);
	j = j+1;
	if (j==30){
		j=0;
		measure = randomNumber(-3, 3)
	}
	var representation = {
		"m2m:cin":{
			"con": measure
		}
	};
	i=i+1;
	console.log("POST "+config.cseUri+"/"+config.aeName+"/"+config.cntName);
	console.log(representation);

	var options = {
		uri: config.cseUri+"/"+config.aeName+"/"+config.cntName,
		method: "POST",
		headers: {
			"X-M2M-Origin": config.aeId,
			"X-M2M-RI": "123456",
			"Content-Type": "application/json;ty=4"
		},
		json: representation
	};

	request(options, function (error, response, body) {
		console.log("◀◀◀◀◀");
		if(error){
			console.log(error);
		}else{
			console.log(response.statusCode);
			console.log(body);
		}
	});
}